SystemOrganization addCategory: 'OrbeonBPMRuntime_Tests'!

TestCase subclass: #BpmProcessExecutionTest
	instanceVariableNames: 'procInstance users roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/21/2016 06:03'!
createFormInstance: xmlMethodName definitionNamed: definitionName app: app
	"The receiver create anOrbeonFormInstance of form definition named <definitionName> of Orbeon Applicaiton named <app> using the method <xmlMethodName> to get the XML string of the form "
	| application definition |

	application := self getApplicationManagerClass getAnyApplicationNamed: app.
	definition := application definitionNamed: definitionName.

	^(OrbeonFormInstance app: app form: definitionName id: UUID new asString)
			definition: definition;
			xmlString: (OrbeonFormInstanceTemplate perform: xmlMethodName);
			processXML;
			yourself! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/07/2015 07:04'!
getAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance
	"The receiver get the assignment for <aBpmTaskInstance> in the process <aBpmProcessInstance>. 
	The task has the form instance <anOrbeonFormInstance>"

	^(self getProcessMatrixFor: aBpmProcessInstance) getAssignmentFor: aBpmTaskInstance ifNone: [self assert: false]! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/07/2015 06:51'!
getProcessMatrix

	^self getProcessMatrixFor: procInstance! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/07/2015 06:51'!
getProcessMatrixFor: aBpmProcessInstance

	^aBpmProcessInstance getProcessMatrix! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/27/2016 16:13'!
getUserNamed: aString

	^users at: aString ifAbsent: [self assert: false]! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/07/2015 06:59'!
processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance
	"The receiver simulate the task processing of <aBpmTaskInstance> by user named <aString> in the process <aBpmProcessInstance>. 
	The task has the form instance <anOrbeonFormInstance>.
	1- Get the actual assignment of the task <aBpmTaskAssignment> from the tasks matrix.
	2- The user take the assignment.
	3- Associate the task and the form instance.
	4- The user finalize the assigment"

	^self processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance on: procInstance! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/27/2016 16:14'!
processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance on: aBpmProcessInstance
	"The receiver simulate the task processing of <aBpmTaskInstance> by user named <aString> in the process <aBpmProcessInstance>. 
	The task has the form instance <anOrbeonFormInstance>.
	1- Get the actual assignment of the task <aBpmTaskAssignment> from the tasks matrix.
	2- The user take the assignment.
	3- Associate the task and the form instance.
	4- The user finalize the assigment"
	| assignment |

	assignment := self takeTask: aBpmTaskInstance forUserNamed: aString withForm: anOrbeonFormInstance on: aBpmProcessInstance.

	(self getUserNamed: aString) finalizeAssignment: assignment.! !

!BpmProcessExecutionTest methodsFor: 'Accessing' stamp: 'BrunoBB 12/07/2015 06:51'!
procInstance
	^procInstance! !

!BpmProcessExecutionTest methodsFor: 'Updating' stamp: 'BrunoBB 12/07/2015 06:51'!
procInstance: newValue
	procInstance := newValue! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/27/2016 16:28'!
takeTask: aBpmTaskInstance forUserNamed: aString withForm: anOrbeonFormInstance on: aBpmProcessInstance
	"The receiver take the task <aBpmTaskInstance> for user named <aString> in the process <aBpmProcessInstance>. 
	The task has the form instance <anOrbeonFormInstance>.
	1- Get the actual assignment of the task <aBpmTaskAssignment> from the tasks matrix.
	2- The user take the assignment.
	3- Associate the task and the form instance.
	4- Answer the assignment <aBpmTaskAssignment>"
	| assignment |

	assignment := self getAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance.

	(self getUserNamed: aString) take: assignment.

	aBpmTaskInstance externalObject: anOrbeonFormInstance.

	^assignment! !

BpmProcessExecutionTest subclass: #BugTrackerProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_analyzeDeveloperReportNo

	^self createFormInstance: #form_analyzeDeveloperReportNo definitionNamed: 'analyze-developer-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_analyzeDeveloperReportYes

	^self createFormInstance: #form_analyzeDeveloperReportYes definitionNamed: 'analyze-developer-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:48'!
formInstance_analyzeIssueNo

	^self createFormInstance: #form_analyzeIssueNo definitionNamed: 'analyze-issue' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:46'!
formInstance_analyzeIssueReportAccept

	^self createFormInstance: #form_analyzeIssueReportAccept definitionNamed: 'analyze-issue-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:47'!
formInstance_analyzeIssueReportReject

	^self createFormInstance: #form_analyzeIssueReportReject definitionNamed: 'analyze-issue-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:48'!
formInstance_analyzeIssueYes

	^self createFormInstance: #form_analyzeIssueYes definitionNamed: 'analyze-issue' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:44'!
formInstance_executeTestFailed

	^self createFormInstance: #form_executeTestFailed definitionNamed: 'execute-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:44'!
formInstance_executeTestPassed

	^self createFormInstance: #form_executeTestPassed definitionNamed: 'execute-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:06'!
formInstance_internalTest

	^self createFormInstance: #form_internalTest definitionNamed: 'internal-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:06'!
formInstance_reportFixes

	^self createFormInstance: #form_reportFixes definitionNamed: 'report-fixes' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:09'!
formInstance_reportSolution

	^self createFormInstance: #form_reportSolution definitionNamed: 'report-solution' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_reportWorkaround

	^self createFormInstance: #form_reportWorkaround definitionNamed: 'report-workaround' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:43'!
formInstance_testCase

	^self createFormInstance: #form_analyzeData1 definitionNamed: 'test-case' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:45'!
formInstance_testOk

	^self createFormInstance: #form_testOk definitionNamed: 'test-ok' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 15:25'!
setUp
	| procDefinition processGenerator |

	users := Dictionary new.

	processGenerator := BpmProcessGenerator exampleTestCaseFixIssueReportArchitect.

	procDefinition := processGenerator getProcessDefinitionNamed: 'test-case-process' ifNone: [self assert: false].

	procInstance := procDefinition createAndStartProcessInstance: nil. "the process is create by an anonynous user"

	users at: 'alberto' put: (BpmUser getUserNamed: 'alberto').! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 19:43'!
tearDown

	procInstance definition removeProcessInstance: procInstance! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 15:55'!
testExecutionTestExecutionFailedRejectIssue
	| currentTask nextTasks gateway endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueReportReject.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	endArtifact := gateway outTransitions last endArtifact.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:47'!
testExecutionTestExecutionOk
	| currentTask nextTasks gateway endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:30'!
testExecutionTestExecutionSubProcessL1
	"Execute the subprocess only to one level (inmediate childs of the top process)"
	| currentTask nextTasks gateway endArtifact subProcess subProcessArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueReportAccept.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	subProcessArtifact := gateway outTransitions last endArtifact.
	subProcess := subProcessArtifact processInstance.
"------------------ Sub Process Execution Starts here -------------------------------"
	self assert:  subProcess isSubProcess.
	self assert: (subProcess startEvent getDefinitionName = 'start').

	currentTask := subProcess currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueYes on: subProcess.
	self assert: (currentTask getDefinitionName = 'analyze-issue').

	gateway := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'can fix').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_reportFixes on: subProcess.
	self assert: (currentTask getDefinitionName = 'report-fixes').

	nextTasks := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_internalTest on: subProcess.
	self assert: (currentTask getDefinitionName = 'internal-test').

	endArtifact := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
"------------------ Sub Process Execution Ends here -------------------------------"
"------------------ Parent Process Execution Starts here -------------------------------"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:41'!
testExecutionTestExecutionSubProcessL2
	"Execute the subprocess only to two level "
	| currentTask nextTasks gateway endArtifact subProcessL1 subProcessArtifactL1 subProcessL2 subProcessArtifactL2 |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueReportAccept.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	subProcessArtifactL1 := gateway outTransitions last endArtifact.
	subProcessL1 := subProcessArtifactL1 processInstance.
	"------------------START::L1:: Sub Process Execution -------------------------------"
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start').

		currentTask := subProcessL1 currentActivities last.
		self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueNo on: subProcessL1.
		self assert: (currentTask getDefinitionName = 'analyze-issue').

		gateway := (subProcessL1 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
		gateway := gateway last.
		self assert: (gateway getDefinitionName = 'can fix').

		subProcessArtifactL2 := gateway outTransitions last endArtifact.
		subProcessL2 := subProcessArtifactL2 processInstance.
		"------------------START::L2:: Sub Process Execution -------------------------------"
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start').

			currentTask := subProcessL2 currentActivities last.
			self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeDeveloperReportYes on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'analyze-developer-report').

			gateway := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
			gateway := gateway last.
			self assert: (gateway getDefinitionName = 'has-solution').

			currentTask := gateway outTransitions last endArtifact.
			self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_reportSolution on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'report-solution').

			endArtifact := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			endArtifact := endArtifact last.
			self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
		"------------------END::L2:: Sub Process Execution -------------------------------"
	"------------------RESUME::L1:: Sub Process Execution -------------------------------"
		endArtifact := subProcessL1 transitions last endArtifact.
		self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
	"------------------END::L1:: Sub Process Execution-------------------------------"
"------------------RESUME::Top:: Process Execution-------------------------------"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.

	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

BpmProcessExecutionTest subclass: #SmaltalksRegistrationExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:03'!
formInstance_acceptRegistration

	^self createFormInstance: #form_acceptRegistration definitionNamed: 'accept-registration' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:02'!
formInstance_analyzeData1

	^self createFormInstance: #form_analyzeData1 definitionNamed: 'analyze-data' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:02'!
formInstance_analyzeData2

	^self createFormInstance: #form_analyzeData2 definitionNamed: 'analyze-data' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 11:56'!
formInstance_registration

	^self createFormInstance: #form_registration definitionNamed: 'registration' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:04'!
formInstance_securityReport

	^self createFormInstance: #form_securityReport definitionNamed: 'security-report' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 15:24'!
setUp
	| procDefinition processGenerator |

	users := Dictionary new.

	processGenerator := BpmProcessGenerator exampleSmalltalksRegistration.

	procDefinition := processGenerator getProcessDefinitionNamed: 'registration' ifNone: [self assert: false].

	procInstance := procDefinition createAndStartProcessInstance: (BpmUser getUserNamed: 'alberto').

	users at: 'alberto' put: (BpmUser getUserNamed: 'alberto').! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/17/2015 12:01'!
tearDown

	procInstance definition removeProcessInstance: procInstance! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:43'!
testExecutionPathRegistrationAccepted
	| currentTask nextTasks gateway endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_registration.
	self assert: (currentTask getDefinitionName = 'registration').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeData1.
	self assert: (currentTask getDefinitionName = 'analyze-data').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'security-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_acceptRegistration.
	self assert: (currentTask getDefinitionName = 'accept-registration').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: (endArtifact getDefinitionName = 'end 1').

	^self assert: true! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:45'!
testExecutionPathRegistrationRejected
	| currentTask nextTasks gateway endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_registration.
	self assert: (currentTask getDefinitionName = 'registration').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeData2.
	self assert: (currentTask getDefinitionName = 'analyze-data').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'security-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_securityReport.
	self assert: (currentTask getDefinitionName = 'security-report').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: (endArtifact getDefinitionName = 'end 2').! !

BpmProcessExecutionTest subclass: #VisaApplianceProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!VisaApplianceProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 15:07'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForVisaProcess.

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'visa-appliance' toApplication: (self getApplicationManagerClass getAnyApplicationNamed: 'ue');
		generateAllProcess.

	^processGenerator getProcessDefinitionNamed: 'visa-appliance' ifNone: [self assert: false].! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:03'!
formInstance_analyze_appliance

	^self createFormInstance: #form_analyze_appliance_1 definitionNamed: 'analyze-appliance' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:08'!
formInstance_applicant_home_office_report

	^self createFormInstance: #form_applicant_home_office_report_1 definitionNamed: 'applicant-home-office-report' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:09'!
formInstance_check_accounts

	^self createFormInstance: #form_check_accounts_1 definitionNamed: 'check-accounts' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:08'!
formInstance_check_applicant_record

	^self createFormInstance: #form_check_applicant_record_1 definitionNamed: 'check-applicant-record' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:01'!
formInstance_check_basic_data

	^self createFormInstance: #form_check_basic_data_1 definitionNamed: 'check-basic-data' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:11'!
formInstance_check_debts

	^self createFormInstance: #form_check_debts_1 definitionNamed: 'check-debts' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:02'!
formInstance_check_previous_appliance

	^self createFormInstance: #form_check_previous_appliance_1 definitionNamed: 'check-previous-appliance' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:11'!
formInstance_check_properties

	^self createFormInstance: #form_check_properties_1 definitionNamed: 'check-properties' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 15:50'!
formInstance_citizen_appliance

	^self createFormInstance: #form_citizen_appliance_1 definitionNamed: 'citizen-appliance' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:06'!
formInstance_emit_visa

	^self createFormInstance: #form_emit_visa_1 definitionNamed: 'emit-visa' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 03/26/2016 16:12'!
formInstance_financial_report

	^self createFormInstance: #form_financial_report_1 definitionNamed: 'financial-report' app: 'ue'! !

!VisaApplianceProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/27/2016 15:48'!
setUp
	| procDefinition |

	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'visa-appliance' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'andrew vo' put: (BpmUser getUserNamed: 'andrew vo').
	users at: 'andrew vm' put: (BpmUser getUserNamed: 'andrew vm').
	users at: 'andrew vc' put: (BpmUser getUserNamed: 'andrew vc').
	users at: 'andrew fo' put: (BpmUser getUserNamed: 'andrew fo').
	users at: 'andrew po' put: (BpmUser getUserNamed: 'andrew po').
	users at: 'andrew do' put: (BpmUser getUserNamed: 'andrew do').

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').! !

!VisaApplianceProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 15:51'!
tearDown

	"procInstance definition removeProcessInstance: procInstance"! !

!VisaApplianceProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/27/2016 16:00'!
testExecuteProcess_visaAccepted
	| currentTask nextTasks gateway endArtifact subProcessL1 subProcessArtifactL1 subProcessL2 subProcessArtifactL2 |

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	"Step 2 - Form [check-basic-data]"
	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	"Step 3 - Gateway Evaluation"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept basic data').
	"Step 4 - Form [check-previous-appliance]"
	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	"Sub Process Execution [home-office-check] starts here "
		nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
		subProcessArtifactL1 := nextTasks last.
		subProcessL1 := subProcessArtifactL1 processInstance.
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').
		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: self formInstance_check_applicant_record.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		"Step 2 [subproc] - Form [applicant-home-office-report]"
		nextTasks := (subProcessL1 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: self formInstance_applicant_home_office_report.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		"Sub Process Execution [check-financial-data]"
			nextTasks := (subProcessL1 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			subProcessArtifactL2 := nextTasks last.
			subProcessL2 := subProcessArtifactL2 processInstance.
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').
			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: self formInstance_check_accounts.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			"Step 2 [subproc] - Form [check-accounts]"
			nextTasks := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			self processTask: currentTask withUserNamed: 'andrew po' withForm: self formInstance_check_properties.
			self assert: (currentTask getDefinitionName = 'check-properties').
			"Step 3 [subproc] - Form [check-accounts]"
			nextTasks := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			self processTask: currentTask withUserNamed: 'andrew do' withForm: self formInstance_check_debts.
			self assert: (currentTask getDefinitionName = 'check-debts').
			"Step 3 [subproc] - Form [check-accounts]"
			nextTasks := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: self formInstance_financial_report.
			self assert: (currentTask getDefinitionName = 'financial-report').
			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"
	"Top Process [visa-appliance] resume execution "
	"Step 5 - Form [analyze-appliance]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_analyze_appliance.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	"Step 6 - Gateway Evaluation"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'granted').
	"Step 7 - Form [emit-visa]"
	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_emit_visa.
	self assert: (currentTask getDefinitionName = 'emit-visa').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).! !

!VisaApplianceProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/27/2016 16:06'!
testExecuteProcess_visaAccepted_2
	| currentTask nextTasks gateway endArtifact subProcessL1 subProcessArtifactL1 subProcessL2 subProcessArtifactL2 |

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	"Step 2 - Form [check-basic-data]"
	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	"Step 3 - Gateway Evaluation"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept basic data').
	"Step 4 - Form [check-previous-appliance]"
	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	"Sub Process Execution [home-office-check] starts here "
		nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
		subProcessArtifactL1 := nextTasks last.
		subProcessL1 := subProcessArtifactL1 processInstance.
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').
		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: self formInstance_check_applicant_record.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		"Step 2 [subproc] - Form [applicant-home-office-report]"
		nextTasks := (subProcessL1 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: self formInstance_applicant_home_office_report.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		"Sub Process Execution [check-financial-data]"
			nextTasks := (subProcessL1 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			subProcessArtifactL2 := nextTasks last.
			subProcessL2 := subProcessArtifactL2 processInstance.
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').
			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: self formInstance_check_accounts.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			"Step 2 [subproc] - Form [check-accounts]"
			nextTasks := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			self processTask: currentTask withUserNamed: 'andrew po' withForm: self formInstance_check_properties.
			self assert: (currentTask getDefinitionName = 'check-properties').
			"Step 3 [subproc] - Form [check-accounts]"
			nextTasks := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			self processTask: currentTask withUserNamed: 'andrew do' withForm: self formInstance_check_debts.
			self assert: (currentTask getDefinitionName = 'check-debts').
			"Step 3 [subproc] - Form [check-accounts]"
			nextTasks := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: self formInstance_financial_report.
			self assert: (currentTask getDefinitionName = 'financial-report').
			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"
	"Top Process [visa-appliance] resume execution "
	"Step 5 - Form [analyze-appliance]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_analyze_appliance.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	"Step 6 - Gateway Evaluation"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'granted').
	"Step 7 - Form [emit-visa]"
	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_emit_visa.
	self assert: (currentTask getDefinitionName = 'emit-visa').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).! !
